import { makeAutoObservable } from "mobx";
import React from "react";
export class ErrorState {
    constructor() {
        this.error = null;
        makeAutoObservable(this);
    }
    update(event) {
        var _a, _b;
        const viteError = event.viteError;
        if (viteError) {
            this.error = {
                title: viteError.err.message,
                details: (React.createElement(React.Fragment, null,
                    ((_a = viteError.err.loc) === null || _a === void 0 ? void 0 : _a.file) && (React.createElement("b", null, `Error in ${viteError.err.loc.file}:${viteError.err.loc.line}:${viteError.err.loc.column}\n\n`)),
                    viteError.err.message,
                    viteError.err.stack && `\n${viteError.err.stack}`)),
            };
        }
        else if (((_b = event.rendering) === null || _b === void 0 ? void 0 : _b.kind) === "error") {
            const message = event.rendering.error;
            const [title, ...rest] = message.split("\n");
            this.error = {
                title: title || "An unknown error has occurred",
                details: rest.length > 0 && rest.join("\n"),
            };
        }
        else {
            this.error = null;
        }
    }
}
